/* Restituisce true se il livello è completato (non ci sono blocchi sullo schermo) */
bool completato()
{
  for (short x = 0; x < width; x++)
    for (short y = 0; y < height; y++)
      { if (block[x][y] >  9 && block[x][y] < 128) return false; }
  return true;
}

class proietto {
  private:
    double x, y;
    double xv, yv;
    angolo direzione;
    double speed;
  public:
    bool init() {
      x = 320; y = 450;
      direzione.cos = cos(M_PI * 3 / 2);
      direzione.sin = sin(M_PI * 3 / 2);
      speed = 0.3;
      return true; }
    bool urto(unsigned int xa, unsigned int ya)
    {
      xa = xa / largBlock; ya = ya / altBlock;
      if (block[xa][ya] > 9) /* Se qui c'è un pezzo... - vedere anche leggimi.txt */
      {
        if (direzione.sin == 0 || direzione.cos == 0) return true; /* Non considera i casi limite */
        switch (block[xa][ya])
        {
          case 10: player.punti = player.punti + 10; block[xa][ya]--;           break;
          case 11: case 12: player.punti = player.punti + 5 ; block[xa][ya]--;  break;
          case 13: player.punti = player.punti + 30; block[xa][ya] = 9;         break;
          case 128: speed = speed - 0.1; if (speed < 0.2) speed = 0.2;           break;
          case 129: speed = speed + 0.1; if (speed > 0.5) speed = 0.5;           break;
          case 130: player.lung = player.lung + 5; if (player.lung > 100) player.lung = 100; break;
          case 131: player.lung = player.lung - 5; if (player.lung < 10)  player.lung = 10;  break;
          case 140: player.vite++; player.punti = player.punti - 50; block[xa][ya] = 9; break;
          case 150: player.punti = player.punti + 200; block[xa][ya] = 13; break;
          case 151: break;
          case 152: block[xa][ya] = 9; break;
          case 153: case 154: block[xa][ya]--; break;
          default: player.punti++; block[xa][ya] = 8; break;
        }
        if (completato()) return false; /* Controsenso, il controllo inverso è già usato */
        /* Fa rimbalzare la pallina */
        int xva = xv / largBlock, yva = yv / altBlock;
        if (xva == xa) direzione.sin = -direzione.sin;
          else if (yva == ya) direzione.cos = -direzione.cos;
            else
            {
              /* Caso eccezionale, il pezzo viene colpito preciso nell'angolo! */
              direzione.cos = -direzione.cos; direzione.sin = -direzione.sin;
              cout << "[I] Extraordinary case: you hit the block in its corner.\n";
            }
        /* e la rimette dov'era prima, onde evitare spiacevoli loop */
        x = xv; y = yv;
      }
      return true;
    }
    char muovi() {
      xv = x; yv = y;
      x = x + speed * direzione.cos;
      y = y - speed * direzione.sin;
      if (! urto(x, y)) return 'c'; /* Livello completato */
      /* Rimbalzo su bordo o paddle */
      if (x >= 639 || x <= 0) direzione.cos = -direzione.cos;
      if (y <= 0) direzione.sin = -direzione.sin;
      if (y >= 460)
      {
        if (x > (player.x - player.lung) && x < (player.x + player.lung))
        {
          /* Calcolo del nuovo coseno dell'angolo in funzione del punto del paddle
             col quale il giocatore urta la palla */
          double corner = (x - (player.x - player.lung)) * M_PI / (player.lung * 2);
          if (corner < M_PI / 12) corner = M_PI / 12;
            else if (corner > M_PI * 11 / 12) corner = M_PI * 11 / 12;
          direzione.cos = -cos(corner);
          if (direzione.sin < 0) player.punti--;
          direzione.sin = sin(corner);
          /* cout << "[I] NEW: SIN: " << direzione.sin << " COS: " << direzione.cos << endl; */
          return 'h';
        }
        else if (y >= 465) return 'l'; /* Pallina persa */
      }
      return 'o';
    }
    bool grafica() { filledCircleColor(schermo, x, y, 5, 0xC8C8C8FF); }
};

/* adattato dalla libreria non standard stdlib.h */
char* itoa(long val, int base){

  static char buf[32] = {0};
  if (val == 0) { buf[0] = '0'; buf[1] = 0; return &buf[0]; }
  bool flag = false;
  if (val < 0) { val = -val; flag = true; }

  int i = 30;

  for(; val && i ; --i, val /= base)

    buf[i] = "0123456789abcdef"[val % base];

  if (flag) { buf[i] = '-'; return &buf[i]; }
    else return &buf[i+1];
}


